function transfer(download, lp, rp, pp, sa) {			// these variables correspond to the ones below - localParent, remoteParent, prompt, skipAll
	if (!isConnected || (download && remoteTree.selection.count == 0) || (!download && localTree.selection.count == 0))
		return;

	var prompt = lp ? pp : true;		// if lp isn't null we're doing a recursive call
	var skipall = lp ? sa : false;
	var resume;
	var localParent = lp ? lp : gLocalPath.value;
	var remoteParent = lp ? rp : gRemotePath.value;
	var files = new Array();

	if (download) {																		// download specific
		if (lp)																			// if recursive
			files = data;
		else																			// else
			for (var x = 0; x < remoteTree.rowCount; ++x)
				if (remoteTree.selection.isSelected(x))
					files.push(remoteTree.data[x]);
	} else {																			// upload specific
		if (lp) {																		// if recursive
			try {
				var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
				dir.initWithPath(localParent);
				var entries = dir.directoryEntries;
				while (entries.hasMoreElements()) {
					var file = entries.getNext().QueryInterface(Components.interfaces.nsIFile);
					if (file.exists() && (!file.isHidden() || hiddenmode))
						files.push(file);
				}
			} catch (ex) {
				debug(ex,26);
				return;	// skip this directory
			}
		} else {																		// else
			for (var x = 0; x < localTree.rowCount; ++x)
				if (localTree.selection.isSelected(x))
					files.push(localTree.data[x]);
		}
	}

	for (var x = 0; x < files.length; ++x) {
		var remotePath = remoteTree.constructPath(remoteParent, files[x].leafName);
		var localPath = localTree.constructPath(localParent, files[x].leafName);
		var isDirectory = download ? files[x].isDirectory : files[x].isDirectory();

		var file;
		if (download) {																	// check to see if file exists
			file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(localPath);
		} else {
			file = { exists: function() { return false; }, };
			var remoteList = lp ? data : remoteTree.data;
			for (var y = 0; y < remoteList.length; ++y)
				if (remoteList[y].leafName == files[x].leafName)
					file = { fileSize: remoteList[y].fileSize, leafName: remoteList[y].leafName, exists: function() { return true; }, };
		}

		if (file.exists() && skipall)
			continue;

		resume = false;
		if (file.exists() && prompt && !isDirectory) {									// ask nicely if file exists
			var response = new Object();
			response.value = 0;
			var timer = destructmode;

			resume = file.fileSize < files[x].fileSize;

			window.openDialog("chrome://fireftp/content/confirmFileDialog.xul","confirmFileDialog",
					"screenY="+(document.getElementById('main-window').boxObject.height/2 - 45+document.getElementById('main-window').boxObject.screenY)
				  +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)
				  +",width=400,height=90,chrome,modal=yes,dialog=yes,resizable=yes", response, file.leafName, resume, false, timer);
			if (response.value == 1)
				resume = false;
			else if (response.value == 2) {
				prompt = false;
				resume = false;
			} else if ((response.value == 3) || (response.value == 0))
				continue;
			else if (response.value == 4)
				resume = true;
			else if (response.value == 5) {
				skipall = true;
				continue;
			}
		}

		if (download) {
			if (isDirectory) {															// if the directory doesn't exist we create it
				if (!file.exists()) {
					try {
						file.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 755);
					} catch (ex) {
						error(strbundle.getString("failedDir") + " '" + remotePath + "' " + strbundle.getString("failedDir2"));
						debug(ex,23);
						continue;
					}
				}

				list(remotePath, "transfer(true," + localPath.toSource() + ",\'" + remotePath + "\'," + prompt + "," + skipall + ")", false);
			} else {																	// download the file
				addEventQueue("TYPE", detectAscii(remotePath));
				addEventQueue("PASV", "", files[x].fileSize);
				if (resume)
					addEventQueue("REST", file.fileSize);
				addEventQueue("RETR", remotePath, localPath);
			}
		} else {
			if (isDirectory) {															// if the directory doesn't exist we create it
				if (!file.exists()) {
					addEventQueue("MKD", remotePath);
					data = new Array();													// we know the new directory is empty
					transfer(false, localPath, remotePath, prompt, skipall);
				} else {
					removeCacheEntry();
					list(remotePath, "removeCacheEntry('" + remotePath + "');transfer(false," + localPath.toSource()
							+ ",\'" + remotePath + "\'," + prompt + "," + skipall + ")", false);
				}
			} else {
				addEventQueue("TYPE", detectAscii(remotePath));							// download the file
				addEventQueue("PASV");
				if (resume)
					addEventQueue("APPE", remotePath, new Array(localPath, file.fileSize));
				else
					addEventQueue("STOR", remotePath, localPath);
			}
		}
	}
	if (isReady && eventQueue.length)	// get the ball rollin' if it isn't already
		writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
}
function detectAscii(path) {														// detect an ascii file - returns "A" or "I"
	if (filemode == 1)																// binary
		return "I";
	if (filemode == 2)																// ASCII
		return "A";

	path = path.substring(path.lastIndexOf('/') + 1);								// manually detect
	path = path.substring(path.lastIndexOf('.') + 1);

	var found = false;
	for (var x = 0; x < prefAsciiFiles.length; ++x)
		if (prefAsciiFiles[x] == path)
			found = true;

	if (found)
		return "A";
	return "I";
}
function onChangeType() {															// change TYPE A/TYPE I/auto from statusbar
	var transferTypes = new Array("Auto", "Binary", "ASCII");
	filemode = (filemode + 1) % 3;
	document.getElementById('statustype').label = transferTypes[filemode];
	savePreferences();
}
