function directorySort(a, b) {
	var tempA = a.path().replace(slash == "\\" ? /\x5c/g : /\x2f/g, "\x01").toLowerCase();	// make '/' less than everything (except null really)
	var tempB = b.path().replace(slash == "\\" ? /\x5c/g : /\x2f/g, "\x01").toLowerCase();

	if (tempA < tempB)
		return -1;
	if (tempA > tempB)
		return 1;
	return 0;
}
function compareLocalName(a, b) {
	if (!a.isDirectory() && b.isDirectory())
		return 1;
	if (a.isDirectory() && !b.isDirectory())
		return -1;
	if (a.leafName.toLowerCase() < b.leafName.toLowerCase())
		return -1;
	if (a.leafName.toLowerCase() > b.leafName.toLowerCase())
		return 1;
	return 0;
}
function compareLocalSize(a, b) {
	if (!a.isDirectory() && b.isDirectory())
		return 1;
	if (a.isDirectory() && !b.isDirectory())
		return -1;
	return a.fileSize - b.fileSize;
}
function compareLocalDate(a, b) {
	if (!a.isDirectory() && b.isDirectory())
		return 1;
	if (a.isDirectory() && !b.isDirectory())
		return -1;
	return a.lastModifiedTime - b.lastModifiedTime;
}
function compareLocalAttr(a, b) {
	if (!a.isDirectory() && b.isDirectory())
		return 1;
	if (a.isDirectory() && !b.isDirectory())
		return -1;
	if (a.permissions < b.permissions)
		return -1;
	if (a.permissions > b.permissions)
		return 1;
	return 0;
}
function compareRemoteName(a, b) {
	if (!a.isDirectory && b.isDirectory)
		return 1;
	if (a.isDirectory && !b.isDirectory)
		return -1;
	if (a.leafName.toLowerCase() < b.leafName.toLowerCase())
		return -1;
	if (a.leafName.toLowerCase() > b.leafName.toLowerCase())
		return 1;
	return 0;
}
function compareRemoteSize(a, b) {
	if (!a.isDirectory && b.isDirectory)
		return 1;
	if (a.isDirectory && !b.isDirectory)
		return -1;
	return a.fileSize - b.fileSize;
}
function compareRemoteDate(a, b) {
	if (!a.isDirectory && b.isDirectory)
		return 1;
	if (a.isDirectory && !b.isDirectory)
		return -1;
	var aTemp = a.date;
	var bTemp = b.date;
	var aMonth = aTemp.substring(0,3);
	var bMonth = bTemp.substring(0,3);
	var curDate = new Date();
	if (a.date.indexOf(':') != -1) // a quirky formula was here b/f (curDate.getYear() + 0), getYear returned 105 for 2005
		aTemp = aTemp + ' ' + (curDate.getFullYear() - (curDate.getMonth() < remoteMonths.search(aMonth) / 4 ? 1 : 0));
	if (b.date.indexOf(':') != -1)
		bTemp = bTemp + ' ' + (curDate.getFullYear() - (curDate.getMonth() < remoteMonths.search(bMonth) / 4 ? 1 : 0));
	return Date.parse(aTemp) - Date.parse(bTemp);
}
function compareRemoteAttr(a, b) {
	if (!a.isDirectory && b.isDirectory)
		return 1;
	if (a.isDirectory && !b.isDirectory)
		return -1;
	if (a.permissions < b.permissions)
		return -1;
	if (a.permissions > b.permissions)
		return 1;
	return 0;
}
