var remoteTree = {
	data 		: new Array,
	rowCount	: 0,
	remoteSize	: 0,
    getCellText : function(row,column) {														// text for the files
		if (row == -1)
			return "";
		switch(column) {
			case "remotename":
				return this.data[row].leafName;
			case "remotesize":
				if (this.data[row].fileSize == '0')
					return "0 KB  ";
				return commas(Math.floor(this.data[row].fileSize / 1024) + 1) + " KB  ";
			case "remotedate":
				return this.data[row].date;
			case "remoteattr":
				return this.data[row].permissions;
			default:
				return " "; // shouldn't get here
		}
    },
	getImageSrc : function(row,col) {															// icons for the files
		if (row == -1)
			return "";
		if (col == "remotename") {
			if (this.data[row].isDirectory)
				return "res/directory.ico";
			if (this.data[row].isSymlink)
				return "res/link.ico";
			return "moz-icon://" + this.data[row].leafName + "?size=16";
		}
	},
	cycleHeader : function(col, elem) {
		var sortDirection = elem.getAttribute("sortDirection") == "ascending" || elem.getAttribute("sortDirection") == "natural"
							? "descending" : "ascending";
		document.getElementById('remotename').setAttribute("sortDirection", "natural");
		document.getElementById('remotesize').setAttribute("sortDirection", "natural");
		document.getElementById('remotedate').setAttribute("sortDirection", "natural");
		document.getElementById('remoteattr').setAttribute("sortDirection", "natural");
		elem.setAttribute("sortDirection", sortDirection);
		this.sort();
	},
	getCellProperties	:	function(row,col,props)		{},
	getLevel			:	function(row)				{ return 0; },
	getRowProperties	:	function(row,props)			{},
	getColumnProperties	:	function(colid,col,props)	{},
	isContainer			:	function(row)				{ return false; },
	isSeparator			:	function(row)				{ return false; },
	isSorted			:	function(row)				{ return false; },
	setTree				:	function(treebox)			{ this.treebox = treebox; },
	
   	// ************************************************* mouseEvent *****************************************************

	dblClick : function(event) {
		if (!isConnected || event.button != 0 || event.originalTarget.localName != "treechildren" || this.selection.count == 0)
			return;

		if (this.data[this.selection.currentIndex].isDirectory) {												// if it's a directory
			if (eventQueue.length)
				return;
			remoteDirTree.changeDir(this.constructPath(gRemotePath.value, this.data[this.selection.currentIndex].leafName));								// navigate to it
		} else if (this.data[this.selection.currentIndex].isSymlink) {											// if it's a symbolic link
			if (checkIsListing())
				return;

			var linkedFile =this.data[this.selection.currentIndex].symlink;
			var parentPath = gRemotePath.value;
			while (linkedFile.indexOf("./") == 0 || linkedFile.indexOf("../") == 0) {
				if (linkedFile.indexOf("./") == 0)
					linkedFile = linkedFile.substring(2);
				else {
					linkedFile = linkedFile.substring(3);
					parentPath = parentPath.substring(0, parentPath.lastIndexOf('/') ? parentPath.lastIndexOf('/') : 1);
				}
			}

			addEventQueue("CWD", this.constructPath(parentPath, linkedFile));
			if (isReady)	// get the ball rollin' if it isn't already
				writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
		}
		else
			transfer(true);																					// else download the file
	},
	click : function(event) {
		if (!isConnected)
			return;
		if (event.button == 1 && !document.getElementById('remotePasteContext').disabled)					// middle-click paste
			this.paste();
	},
	mouseOver : function(event) {																			// display remote folder info
		if (this.rowCount)
			document.getElementById('statustxt').label =
				strbundle.getString("remoteListing") + " " + this.rowCount + " " + strbundle.getString("objects") + " " + commas(this.remoteSize);
		else
			document.getElementById('statustxt').label = strbundle.getString("remoteListingNoObjects");
	},

	// ************************************************* keyEvent *****************************************************

	keyPress : function(event) {
		if (!isConnected || this.rowCount == 0 || this.selection.count == 0)
			return;

		if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
			this.selection.currentIndex = this.rowCount - 1;

		if (event.keyCode == 13) {								// enter
			if (this.selection.count == 1 && this.data[this.selection.currentIndex].isDirectory) {				// if it's a directory
				if (eventQueue.length)
					return;

				remoteDirTree.changeDir(this.constructPath(gRemotePath.value, this.data[this.selection.currentIndex].leafName));		// navigate to it
			}
			else
				transfer(true);																					// else retrieve a file
		} else if (event.ctrlKey && (event.which == 65 || event.which == 97)) {
			event.preventDefault();								// ctrl-a: select all
			this.selection.selectAll();
		} else if (event.ctrlKey && event.which == 32)			// ctrl-space, select or deselect
			this.selection.toggleSelect(this.selection.currentIndex);
		else if (event.keyCode == 8) {							// backspace
			event.preventDefault();
			remoteDirTree.cdup();
		}
		else if (event.keyCode == 116) {						// F5
			event.preventDefault();
			this.refresh();
		} else if (event.keyCode == 113)						// F2
			this.rename();
		else if (event.charCode == 109 && event.ctrlKey) {		// ctrl-m
			event.preventDefault();
			this.createDirectory();
		} else if (event.keyCode == 46)							// del
			this.remove();
		else if (event.keyCode == 93) {							// display context menu
			var x = {};		var y = {};		var width = {};		var height = {};	
			this.treebox.getCoordsForCellItem(this.selection.currentIndex, "remotename", "text", x, y, width, height);
			document.getElementById('remotemenu').showPopup(
					gRemoteTreeChildren, gRemoteTreeChildren.boxObject.x + 75, gRemoteTreeChildren.boxObject.y + y.value + 5, "context");
		} else if (event.charCode == 112 && event.ctrlKey) {	// ctrl-p
			event.preventDefault();
			this.showProperties();
		} else if (event.charCode == 120 && event.ctrlKey) {	// ctrl-x
			event.preventDefault();
			this.cut();
		} else if (event.charCode == 118 && event.ctrlKey) {	// ctrl-v
			event.preventDefault();
			this.paste();
		}
	},

 	// ************************************************* file functions ***************************************************

	constructPath : function(parent, leafName) {
		return parent + (parent.charAt(parent.length - 1) != '/' ? '/' : '') + leafName;
	},
	createDirectory : function() {
		if (!isConnected || eventQueue.length)
			return;
		var dir = window.prompt(strbundle.getString("directoryName"), "", strbundle.getString("newDirectory"));
		if (!dir)
			return;

		addEventQueue("MKD", this.constructPath(gRemotePath.value, dir), refreshmode ? "remoteTree.refresh()" : "");
		if (isReady)
			writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
	},
	remove : function() {
		if (!isConnected || eventQueue.length || this.selection.count == 0
			|| !window.confirm(strbundle.getString("confirmDelete") + " " + gRemoteTree.view.selection.count + " " + strbundle.getString("confirmDelete2")))
			return;

		var last = true;
		for (var x = 0; x < this.rowCount; ++x)
			if (this.selection.isSelected(x)) {
				var remotepath = this.constructPath(gRemotePath.value, this.data[x].leafName);
				if (this.data[x].isDirectory) {												// delete a subdirectory recursively
					eventQueue.unshift( { cmd: "RMD", parameter: remotepath, remember: (last && refreshmode) ? "remoteTree.refresh()" : "" } );
					list(remotepath, "remoteTree.removeRecursive(\'" + remotepath + "\')", false, true);// get list of subfiles
				} else																		// delete a file
					eventQueue.unshift( { cmd: "DELE", parameter: remotepath, remember: (last && refreshmode) ? "remoteTree.refresh()" : "" } );
				last = false;
			}
		if (isReady)
			writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
	},
	removeRecursive : function(parent) {													// delete subdirectories and files
		var files = data;
		
		for (var x = 0; x < files.length; ++x) {
			var remotepath = this.constructPath(parent, files[x].leafName);

			if (files[x].isDirectory) {														// delete a subdirectory recursively
				eventQueue.unshift( { cmd: "RMD", parameter: remotepath, remember: "" } );
				list(remotepath, "remoteTree.removeRecursive(\'" + remotepath + "\')", false, true);
			} else																			// delete a file
				eventQueue.unshift( { cmd: "DELE", parameter: remotepath, remember: "" } );
		}
	},
	rename : function() {
		if (!isConnected || this.rowCount == 0 || eventQueue.length || this.selection.count == 0)
			return;

		if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
			this.selection.currentIndex = this.rowCount - 1;

		var path = this.constructPath(gRemotePath.value, this.data[this.selection.currentIndex].leafName);

		var newName = window.prompt(strbundle.getString("renameTo"), path.substring(path.lastIndexOf('/') + 1), strbundle.getString("rename"));
		if (!newName)
			return;
		
		if (path.charAt(path.length - 1) == '/')
			path = path.substring(path.length - 1);
		newName = path.substring(0, path.lastIndexOf('/')) + '/' + newName;
		
		addEventQueue("RNFR", path);								// rename the file
		addEventQueue("RNTO", newName, refreshmode ? "remoteTree.refresh()" : "");
		if (isReady)
			writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
	},
	showProperties : function() {
		if (this.selection.count == 0 || this.rowCount == 0)
			return;

		if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
			this.selection.currentIndex = this.rowCount - 1;

		var index = this.selection.currentIndex;

		thePath = this.constructPath(gRemotePath.value, this.data[index].leafName);

		var permissions = new Object();
		permissions.value = "";

		window.openDialog("chrome://fireftp/content/propertiesDialog.xul","propertiesDialog",
			"screenY="+(document.getElementById('main-window').boxObject.height/2 - 150+document.getElementById('main-window').boxObject.screenY)
		  +",screenX="+(document.getElementById('main-window').boxObject.width /2 - 300+document.getElementById('main-window').boxObject.screenX)
		  +",width=600,height=300,chrome,modal=yes,dialog=yes,resizable=yes",
			thePath, this.data[index].leafName, this.data[index].fileSize, this.data[index].date, this.data[index].permissions, 'disabled', 'disabled',
			this.data[index].isDirectory, this.data[index].user, this.data[index].group, permissions, this.data[index].isSymlink, this.data[index].symlink);

		if (permissions.value && isConnected && eventQueue.length == 0) {											// permissions were changed; CHMOD!
			addEventQueue("SITE CHMOD", permissions.value + ' ' + thePath, refreshmode ? "remoteTree.refresh()" : "");
			if (isReady)
				writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
		}
	},

	// ****************************************************** refresh ***************************************************

	refresh : function() {
		this.data = null;																			// clear remoteTree to make it look like refreshing
		this.treebox.rowCountChanged(0, -this.rowCount);
		this.rowCount = 0;

		if (remoteDirTree.data[remoteDirTree.selection.currentIndex].empty)							// if remoteDirTree is empty
			remoteDirTree.data[remoteDirTree.selection.currentIndex].empty = false;					// it's not anymore

		if (remoteDirTree.data[remoteDirTree.selection.currentIndex].open) {						// if remoteDirTree is open
			remoteDirTree.toggleOpenState(remoteDirTree.selection.currentIndex);					// close it up
			remoteDirTree.data[remoteDirTree.selection.currentIndex].children = null;				// reset its children
			removeCacheEntry(remoteDirTree.data[remoteDirTree.selection.currentIndex].path());		// clear out cache entry
			remoteDirTree.updateViewAfter = true;													// refresh remoteTree afterwards
			remoteDirTree.toggleOpenState(remoteDirTree.selection.currentIndex);					// and open it up again
		} else
			this.updateView(true);
	},

	// ****************************************************** updateView ***************************************************

	updateView : function(skipCache) {
		list(gRemotePath.value, "remoteTree.updateView2()", skipCache);
	},
					  
	updateView2 : function(column, direction) {
		var remoteTreeItems = data;

		this.remoteSize = 0;																			// get directory size
		for (var x = 0; x < remoteTreeItems.length; ++x) {
			var size = parseInt(remoteTreeItems[x].fileSize); 
			if (size != 0)
				size = parseInt(size / 1024) + 1;
			this.remoteSize += size;
		}
		this.remoteSize = parseSize(this.remoteSize);

		this.data = remoteTreeItems;																	// update remoteTree
		this.sort();

		remoteDirTree.reselectCurrentDirectory();														// select directory in remoteDirTree
		if (this.data.length)
			this.selection.select(0);																	// select first element in localTree
	},
	sort : function() {
		if (document.getElementById('remotename').getAttribute("sortDirection") &&
				document.getElementById('remotename').getAttribute("sortDirection") != "natural") {
			this.data.sort(compareRemoteName);
			if (document.getElementById('remotename').getAttribute("sortDirection") == "ascending")
				this.data.reverse();
		}
		if (document.getElementById('remotesize').getAttribute("sortDirection") && 
				document.getElementById('remotesize').getAttribute("sortDirection") != "natural") {
			this.data.sort(compareRemoteSize);
			if (document.getElementById('remotesize').getAttribute("sortDirection") == "ascending")
				this.data.reverse();
		}
		if (document.getElementById('remotedate').getAttribute("sortDirection") &&
				document.getElementById('remotedate').getAttribute("sortDirection") != "natural") {
			this.data.sort(compareRemoteDate);
			if (document.getElementById('remotedate').getAttribute("sortDirection") == "ascending")
				this.data.reverse();
		}
		if (document.getElementById('remoteattr').getAttribute("sortDirection") &&
				document.getElementById('remoteattr').getAttribute("sortDirection") != "natural") {
			this.data.sort(compareRemoteAttr);
			if (document.getElementById('remoteattr').getAttribute("sortDirection") == "ascending")
				this.data.reverse();
		}

		this.treebox.rowCountChanged(0, -this.rowCount);
		this.rowCount = this.data.length;
		this.treebox.rowCountChanged(0, this.rowCount);
	},

  	// ************************************************* cut, copy, paste *****************************************************

	pasteFiles : new Array,
	oldParent : "",
	cut : function () {
		if (!isConnected || this.selection.count == 0)
			return;

		this.pasteFiles = new Array;
		this.oldParent = gRemotePath.value;
		for (var x = 0; x < this.rowCount; ++x)												// put files to be cut/copied in an array to be used when pasting
			if (this.selection.isSelected(x))
				this.pasteFiles.push(this.constructPath(gRemotePath.value, this.data[x].leafName));

		document.getElementById('remotePasteContext').setAttribute("disabled", false);		// enable pasting
	},
	paste : function() {
		if (!isConnected || this.pasteFiles.count == 0)
			return;

		var newParent = gRemotePath.value;
		if (newParent.indexOf(this.pasteFiles[0].path) != -1)								// can't copy into a subdirectory of itself
			return;

		var prompt = true;
		var skipall = false;

		for (var x = 0; x < this.pasteFiles.length; ++x) {
			var leafName = this.pasteFiles[x].substring(this.pasteFiles[x].lastIndexOf('/') + 1)
			var newPath = this.constructPath(newParent, leafName);

			var exists = false;
			for (var y = 0; y < this.data.length; ++y)
				if (this.data[y].leafName == leafName) {
					exists = true;
					break;
				}
			if (exists && skipall)
				continue;
			if (exists && prompt) {
				var response = new Object();
				response.value = 0;
				var timer = destructmode;

				window.openDialog("chrome://fireftp/content/confirmFileDialog.xul","confirmFileDialog",
					"screenY="+(document.getElementById('main-window').boxObject.height/2 - 45+document.getElementById('main-window').boxObject.screenY)
				  +",screenX="+(document.getElementById('main-window').boxObject.width/2 - 200+document.getElementById('main-window').boxObject.screenX)+
					",width=400,height=90,chrome,modal=yes,dialog=yes,resizable=yes",
					response, leafName, true, true, timer);
				if (response.value == 2)
					prompt = false;
				else if (response.value == 3)
					continue;
				else if (response.value == 4 || response.value == 0)
					return;
				else if (response.value == 5) {
					skipall = true;
					continue;
				}
			}

			addEventQueue("RNFR", this.pasteFiles[x]);
			addEventQueue("RNTO", newPath, x == this.pasteFiles.length - 1 && refreshmode ? "remoteTree.refresh()" : "");
		}

		var indexOfOldParent = remoteDirTree.indexOfPath(this.oldParent);
		if (remoteDirTree.data[indexOfOldParent].open) {									// we reset the oldParent's directory tree
			remoteDirTree.toggleOpenState(indexOfOldParent);
			remoteDirTree.data[indexOfOldParent].children = null;
		}

		this.pasteFiles = new Array;
		document.getElementById('remotePasteContext').setAttribute("disabled", true);

		if (isReady)	// get the ball rollin' if it isn't already
			writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
	},
			
	// ************************************************* dragEvent *****************************************************

	dragOver : function(event) {
		if (!isConnected)
			return;

		var dragSession = whataDrag.getCurrentSession();
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);

		trans.addDataFlavor("text/unicode");
		dragSession.getData(trans, 0);

		var bestFlavor = new Object();		var dataObj = new Object();		var len = new Object();
		trans.getAnyTransferData(bestFlavor, dataObj, len);
		dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);

		var row = {};		var col = {};		var child = {};
		this.treebox.getCellAt(event.pageX, event.pageY, row, col, child);

		dragSession.canDrop = dataObj.data == "localtreechildren";
	},
	dragDrop : function(event) {
		var dragSession = whataDrag.getCurrentSession();
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);

		trans.addDataFlavor("text/unicode");
		dragSession.getData(trans, 0);

		var bestFlavor = new Object();		var dataObj = new Object();		var len = new Object();
		trans.getAnyTransferData(bestFlavor, dataObj, len);
		dataObj = dataObj.value.QueryInterface(Components.interfaces.nsISupportsString);

		if (dataObj.data == "localtreechildren")										// upload file
			transfer(false);
		event.preventBubble();
	},
};
